<?php
namespace Fiscal\Logic\Apuracoes;

use Geral\Util\TratamentoDeMensagens;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Fiscal\Entities\Itmaparecup;
use \Indeterminado\Entities\Infadicmapa;
use \Indeterminado\Entities\Mapaapurestado;
use \Indeterminado\Entities\Ajustmapaapursg;
use \Setforms2\Shared\Registry;
use \Fiscal\Logic\Apuracoes\Exceptions\ExcecaoImpostosGerais;
use \Fiscal\Entities\Detaufmapaest;
use \Fiscal\Entities\Mapaapurac;
use \Fiscal\Entities\Maparecup;

class ImpostosGerais{

    /** public static function UpdateGuiaFisc($nrsequmapapu, $dtvencguia, $dshistguia, $vrreceguia, $vrjuroguia, $vrmultaguia, 
                                          $vrtotaguia, $cdimposto, $cdreceitacontr, $nmreceitacontr, $nrorg){
        
        @var $mapaapurac Mapaapurac *
        $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndCdimpostoAndNrorg($nrsequmapapu, $cdimposto, $nrorg);
        $mapaapurac->setNrsequmapapu($nrsequmapapu);
        $mapaapurac->setDtvencguia($dtvencguia);
        $mapaapurac->setDshistguia($dshistguia);
        $mapaapurac->setVrreceguia($vrreceguia);
        $mapaapurac->setVrjuroguia($vrjuroguia);
        $mapaapurac->setVrmultaguia($vrmultaguia);
        $mapaapurac->setVrtotaguia($vrtotaguia);
        $mapaapurac->persist(); */
        
        /** @var $codreceitacontr Codreceitacontr 
        $codreceitacontr = Codreceitacontr::findOneByCdimpostoAndCdreceitacontrAndNrorg(
                                                                    $cdimposto, $cdreceitacontr, $nrorg);
        $codreceitacontr->setCdreceitacontr($cdreceitacontr);
        $codreceitacontr->setNmreceitacontr($nmreceitacontr);
        $codreceitacontr->setNrorg($nrorg);
        $codreceitacontr->persist();
        Registry::getEntityManager()->flush();

    }

    public static function DeleteGuiaFisc($cdreceitacontr, $nmreceitacontr, $nrorg){
        /** @var $codreceitacontr \Indeterminado\Entities\Codreceitacontr 
        $codreceitacontr = Codreceitacontr::findOneByCdreceitacontrAndNrorg($cdreceitacontr, $nrorg);
        $codreceitacontr->delete();
        $codreceitacontr->persist();
        Registry::getEntityManager()->flush();
    }*/

    public static function InsereCalc($idativo, $nrsequmapapu, $idcredpresumido, $idtipoitmapr, $nrseqitmapr, $dsitemmapr,
                                      $vritemmapr, $cdajusteitmapa, $cdajusteitsef, $cditprocedencia, $cditemocor,
                                      $dsitemocor, $dsflegalocor, $cdtipoitmapr, $cdfilial, $nrlanctonf, $nrorg, $data, $operador, $iddifalmanual){

        /** @var $select Itmaparecup */
        $select = Itmaparecup::findOneByNrsequmapapuAndNrseqitmaprAndNrseqitmaprAndNrorg($nrsequmapapu, $idtipoitmapr,
            $nrseqitmapr, $nrorg
        );
        if ($select != null){
            ExcecaoImpostosGerais::Validacao01();
        }
        else{
            $itmaparecup = new Itmaparecup;
            $itmaparecup->setIdativo($idativo);
            $itmaparecup->setNrsequmapapu($nrsequmapapu);
            $itmaparecup->setIdcredpresumido($idcredpresumido);
            $itmaparecup->setIdtipoitmapr($idtipoitmapr);
            $itmaparecup->setNrseqitmapr($nrseqitmapr);
            $itmaparecup->setDsitemmapr($dsitemmapr);
            $itmaparecup->setVritemmapr($vritemmapr);
            $itmaparecup->setCdajusteitmapa($cdajusteitmapa);
            $itmaparecup->setCdajusteitsef($cdajusteitsef);
            $itmaparecup->setCditprocedencia($cditprocedencia);
            $itmaparecup->setCditemocor($cditemocor);
            $itmaparecup->setDsitemocor($dsitemocor);
            $itmaparecup->setDsflegalocor($dsflegalocor);
            $itmaparecup->setCdtipoitmapr($cdtipoitmapr);
            $itmaparecup->setCdfilial($cdfilial);
            $itmaparecup->setNrlanctonf($nrlanctonf);
            $itmaparecup->setIddifalmanual($iddifalmanual);

            $itmaparecup->setNrorg($nrorg);
            $itmaparecup->setDtinclusao($data);
            $itmaparecup->setCdoperinclusao($operador);
            $itmaparecup->setNrorginclusao($nrorg);
            $itmaparecup->setCdoperultatu($operador);
            $itmaparecup->setDtultatu($data);
            $itmaparecup->setNrorgultatu($nrorg);

            $itmaparecup->persist();
            Registry::getEntityManager()->flush();
        }
    }

    public static function UpdateCalc($idativo, $nrsequmapapu, $idcredpresumido, $idtipoitmapr, $nrseqitmapr, $dsitemmapr,
                                      $vritemmapr, $cdajusteitmapa, $cdajusteitsef, $cditprocedencia, $cditemocor,
                                      $dsitemocor, $dsflegalocor, $cdtipoitmapr, $cdfilial, $nrlanctonf, $nrorg, $data, $operador){

        /** @var $itmaparecup Itmaparecup */
        $itmaparecup = Itmaparecup::findOneByNrsequmapapuAndNrseqitmaprAndIdtipoitmaprAndNrorg($nrsequmapapu, $nrseqitmapr,
                                                                                                 $idtipoitmapr, $nrorg);
        $itmaparecup->setIdativo($idativo);
        $itmaparecup->setNrsequmapapu($nrsequmapapu);
        $itmaparecup->setIdcredpresumido($idcredpresumido);
        $itmaparecup->setIdtipoitmapr($idtipoitmapr);
        $itmaparecup->setNrseqitmapr($nrseqitmapr);
        $itmaparecup->setDsitemmapr($dsitemmapr);
        $itmaparecup->setVritemmapr($vritemmapr);
        $itmaparecup->setCdajusteitmapa($cdajusteitmapa);
        $itmaparecup->setCdajusteitsef($cdajusteitsef);
        $itmaparecup->setCditprocedencia($cditprocedencia);
        $itmaparecup->setCditemocor($cditemocor);
        $itmaparecup->setDsitemocor($dsitemocor);
        $itmaparecup->setDsflegalocor($dsflegalocor);
        $itmaparecup->setCdtipoitmapr($cdtipoitmapr);
        $itmaparecup->setCdfilial($cdfilial);
        $itmaparecup->setNrlanctonf($nrlanctonf);

        $itmaparecup->setNrorg($nrorg);
        $itmaparecup->setDtinclusao($data);
        $itmaparecup->setCdoperinclusao($operador);
        $itmaparecup->setNrorginclusao($nrorg);
        $itmaparecup->setCdoperultatu($operador);
        $itmaparecup->setDtultatu($data);
        $itmaparecup->setNrorgultatu($nrorg);

        $itmaparecup->persist();
        Registry::getEntityManager()->flush();

    }

    public static function DeleteCalc($nrsequmapapu, $nrseqitmapr, $nrorg){

        /** @var $itmaparecup Itmaparecup */
        $itmaparecup = Itmaparecup::findOneByNrsequmapapuAndNrseqitmaprAndNrorg($nrsequmapapu, $nrseqitmapr,
                                                                                                 $nrorg);
        $itmaparecup->delete();
        Registry::getEntityManager()->flush();
    }

    public static function SeqNrseqinfadic($nrsequmapapu, $nrorg){

        /** @var $Infadicmapa Infadicmapa */
        $Infadicmapa = Infadicmapa::getObjectsByWhere("NRSEQUMAPAPU = ? AND NRORG = ?",
                                                                               array(
                                                                                   $nrsequmapapu,
                                                                                   $nrorg
                                                                               ));

        if ($Infadicmapa == null){
            $nrseqinfadic = 1;
        }
        else{
            $seqinfadic = array();
            foreach ($Infadicmapa as $item){
                /** @var $item Infadicmapa */
                $seqinfadic[] = $item->getNrseqinfadic();
            }
            $cont = count($seqinfadic);
            $nrseqinfadic = $seqinfadic[$cont-1] + 1;
        }
        tk_set_field_value('NRSEQINFADIC',$nrseqinfadic);
    }

    public static function SeqNrsequdetuf($nrsequmapapu, $nrorg){
        /** @var $Detaufmapaest Detaufmapaest */
        $Detaufmapaest = Detaufmapaest::getObjectsByWhere("NRSEQUMAPAPU = ? AND NRORG = ?",
                                                            array(
                                                                $nrsequmapapu,
                                                                $nrorg
                                                            ));

        if ($Detaufmapaest == null){
            $nrsequdetuf = 1;
        }
        else{
            $sequdetuf = array();
            foreach ($Detaufmapaest as $item){
                /** @var $item Detaufmapaest */
                $sequdetuf[] = $item->getNrsequdetuf();
            }
            $cont = count($sequdetuf);
            $nrsequdetuf = $cont + 1;
        }

        tk_set_field_value('NRSEQUDETUF',$nrsequdetuf);
    }

    public static function SugereDetalhamento($nrsequmapapu, $cdrecesubtrib, $pais, $sgestado, $nrorg){

        /** @var $detaufmapaest Detaufmapaest */
        $detaufmapaest = Detaufmapaest::getObjectsByWhere('NRSEQUMAPAPU = ? AND CDPAIS = ? AND
                                                                           SGESTADO = ? AND NRORG = ?', array(
                                                                           $nrsequmapapu, $pais, $sgestado, $nrorg)
                                                                           );
        if ($detaufmapaest == null){
            $vrreceita = 0;
        }
        else{
            $vrreceita = 0;
            foreach ($detaufmapaest as $item){
                /** @var $item Detaufmapaest */
                    $vrreceita += $item->getVrreceita();
            }
        }

        /** @var $mapaapurestado Mapaapurestado */
        $mapaapurestado = Mapaapurestado::findOneByNrsequmapapuAndCdrecesubtribAndNrorg($nrsequmapapu, $cdrecesubtrib,
                                                                                        $nrorg);
        $impArecolher = $mapaapurestado->getVrimparecolher();
        $vrreceita = $impArecolher - $vrreceita;

        tk_set_field_value('VRRECEITA', $vrreceita);
    }

    public static function OutrosValores($nrsequmapapu, $cdrecesubtrib, $vrajusteapursg, $idtpajusteapsg,
                                         $vrimparecolher, $cdpais, $sgestado, $nrseqajusapursg, $cdobrigacao, $nrorg){

        /** @var $mapaapurestado Mapaapurestado */
        //Consulta da guia para alterar a tabela no momento que salvar 'outros valores'
        $mapaapurestado = Mapaapurestado::findOneByNrsequmapapuAndCdrecesubtribAndNrorg($nrsequmapapu, $cdrecesubtrib,
                                                                                                        $nrorg);
        
        /** @var $ajustmapaapursg Ajustmapaapursg */
        $ajustmapaapursg = Ajustmapaapursg::getObjectsByWhere('NRSEQUMAPAPU = ? AND
                                                             IDTPAJUSTEAPSG = ? AND
                                                                     CDPAIS = ? AND
                                                                   SGESTADO = ? AND
                                                                      NRORG = ?',
                                                             array($nrsequmapapu,
                                                                 $idtpajusteapsg,
                                                                         $cdpais,
                                                                       $sgestado,
                                                                          $nrorg)
                                                             );
        $debitos = 0;
        $creditos = 0;
        if ($ajustmapaapursg == null){
            $outrosDeb = 0;
            $outrosCred = 0;
        }
        else{
            $outrosDeb = 0;
            $outrosCred = 0;
            foreach ($ajustmapaapursg as $item){
                /** @var $item Ajustmapaapursg */
                if (($idtpajusteapsg == 'C') and ($nrseqajusapursg != $item->getNrseqajusapursg())){
                    $outrosCred += $item->getVrajusteapursg();
                }
                elseif (($idtpajusteapsg == 'D') and ($nrseqajusapursg != $item->getNrseqajusapursg())){
                    $outrosDeb += $item->getVrajusteapursg();
                }
            }
        }
        
        if ($idtpajusteapsg == 'C') {
                $creditos = $vrajusteapursg + $outrosCred;
                //soma dos outros valores para abater na guia de arrecadacao
                $mapaapurestado->setVroutroscreditos($creditos);
            }
            elseif ($idtpajusteapsg == 'D') {
                $debitos = $vrajusteapursg + $outrosDeb;
                $mapaapurestado->setVroutrosdebitos($debitos);
            }
        $mapaapurestado->setVrimparecolher(($vrimparecolher - $outrosDeb + $outrosCred) + $debitos - $creditos);
        $mapaapurestado->persist();
        Registry::getEntityManager()->flush();
            
        $detaufmapaest = Detaufmapaest::getRepository()->CdobrigacaoTrue($nrsequmapapu, $cdobrigacao, $cdpais, $sgestado, $nrorg);
        
        $dtvencimento = \Geral\Util\DateUtil::getDataAtual();
        if ($idtpajusteapsg === 'D'){
            if ($detaufmapaest == null){

                $repository = Detaufmapaest::getRepository()->MaxNrsequdetuf($nrsequmapapu, $cdpais, $sgestado, $nrorg);
                $nrsequdetuf = $repository+1;

                /** @var Detaufmapaest $insert */
                $insert = new Detaufmapaest();
                $insert->setIdativo('S');
                $insert->setNrsequmapapu($nrsequmapapu);
                $insert->setCdpais($cdpais);
                $insert->setSgestado($sgestado);
                $insert->setNrsequdetuf($nrsequdetuf);
                $insert->setCdobrigacao($cdobrigacao);
                $insert->setCdreceita($cdobrigacao);
                $insert->setDshistorico('');
                $insert->setNrprocesso('');
                $insert->setIdorigemdet('');
                $insert->setVrreceita($vrajusteapursg);
                $insert->setDtvencdet($dtvencimento);
                $insert->setNrorg($nrorg);
                
                $insert->persist();
                Registry::getEntityManager()->flush();
            }
            else{
                /** @var $select Detaufmapaest */
                $select = Detaufmapaest::findOneByNrsequmapapuAndCdobrigacaoAndSgestadoAndNrorg($nrsequmapapu,
                                                                             $cdobrigacao, $sgestado, $nrorg);
                                                    
                $vrreceitaDeta = $select->getVrreceita();
                $select->setVrreceita($vrreceitaDeta + $vrajusteapursg);
                $select->setDtvencdet($dtvencimento);
                $select->persist();
                Registry::getEntityManager()->flush();
            }
        }
        else{
            if ($detaufmapaest == null){
                ExcecaoImpostosGerais::Validacao06();
            }
            else{
                /** @var $select Detaufmapaest */
                $select = Detaufmapaest::findOneByNrsequmapapuAndCdobrigacaoAndSgestadoAndNrorg($nrsequmapapu,
                                                                             $cdobrigacao, $sgestado, $nrorg);
                                                    
                $vrreceitaDeta = $select->getVrreceita();
                if ($vrreceitaDeta < $vrajusteapursg){
                    ExcecaoImpostosGerais::Validacao07();
                }else{
                    $select->setVrreceita($vrreceitaDeta - $vrajusteapursg);
                    $select->setDtvencdet($dtvencimento);
                    $select->persist();
                    Registry::getEntityManager()->flush();
                }
            }
        }
       
        
        tk_reload_data_with_filter('tab_pbi00140_000_04_GuiadeArrecadacao', 'win_pbi00140_000_04');
        tk_reload_data_with_filter('tab_pbi00140_000_04_DetalhamentoporUF', 'win_pbi00140_000_04');

    }

    public static function testeDifValores($nrsequmapapu, $cdrecesubtrib, $cdpais, $sgestado, $nrorg){
        /** @var $mapaapurestado Mapaapurestado */
        $mapaapurestado = Mapaapurestado::findOneByNrsequmapapuAndCdrecesubtribAndNrorg($nrsequmapapu, $cdrecesubtrib,
                                                                                        $nrorg);

        /** @var $ajustmapaapursg Ajustmapaapursg */
        $ajustmapaapursg = Ajustmapaapursg::findOneByNrsequmapapuAndCdpaisAndSgestadoAndNrorg($nrsequmapapu, $cdpais,
                                                                                              $sgestado, $nrorg);

        if ($ajustmapaapursg == null){
            $vrajusteapursg = 0;
        }
        else{
            $vrajusteapursg = $ajustmapaapursg->getVrajusteapursg();
        }
        $impARecolher = $mapaapurestado->getVrimparecolher();
        $total = $impARecolher + $vrajusteapursg;

        if ($total != $impARecolher){
            ExcecaoImpostosGerais::Validacao02();
        }
    }

    public static function ValiDetal($nrsequmapapu, $cdrecesubtrib, $pais, $sgestado, $receita, $nrorg){

        /** @var $detaufmapaest Detaufmapaest */
        $detaufmapaest = Detaufmapaest::getObjectsByWhere('NRSEQUMAPAPU = ? AND CDPAIS = ? AND
                                                                           SGESTADO = ? AND NRORG = ?',
                                                                           array($nrsequmapapu, $pais, $sgestado, $nrorg)
                                                                           );
        if ($detaufmapaest == null){
            $vrreceita = 0;
        }
        else{
            $vrreceita = 0;
            foreach ($detaufmapaest as $item){
                /** @var $item Detaufmapaest */
                $vrreceita += $item->getVrreceita();
            }
        }

        /** @var $mapaapurestado Mapaapurestado */
        $mapaapurestado = Mapaapurestado::findOneByNrsequmapapuAndCdrecesubtribAndNrorg($nrsequmapapu, $cdrecesubtrib,
                                                                                        $nrorg);
        $impArecolher = $mapaapurestado->getVrimparecolher();
        $vrreceita = $receita + $vrreceita;

        if ($impArecolher < $vrreceita){
            ExcecaoImpostosGerais::Validacao03();
        }
        tk_set_field_value('VRRECEITA', $receita);
    }

    public static function BloqValDif($nrsequmapapu, $cdrecesubtrib, $pais, $sgestado, $nrorg){
        /** @var $detaufmapaest Detaufmapaest */
        $detaufmapaest = Detaufmapaest::getObjectsByWhere('NRSEQUMAPAPU = ? AND CDPAIS = ? AND
                                                                           SGESTADO = ? AND NRORG = ?',
                                                                           array($nrsequmapapu, $pais, $sgestado, $nrorg)
                                                                           );
        if ($detaufmapaest == null){
            $vrreceita = 0;
        }
        else{
            $vrreceita = 0;
            foreach ($detaufmapaest as $item){
                /** @var $item Detaufmapaest */
                $vrreceita += $item->getVrreceita();
            }
        }

        /** @var $mapaapurestado Mapaapurestado */
        $mapaapurestado = Mapaapurestado::findOneByNrsequmapapuAndCdrecesubtribAndNrorg($nrsequmapapu,
                                                                                        $cdrecesubtrib, $nrorg);
        $impArecolher = $mapaapurestado->getVrimparecolher();

        if ($vrreceita != $impArecolher){
//            tk_select_tab('tab_pbi00140_000_04_DetalhamentoporUF');
//            ExcecaoImpostosGerais::Validacao04();
            tk_abort("Detalhamento não está completo.");
        }
        else{
            return true;
        }
    }

    public static function AtGuiaPosDelete($nrsequmapapu, $vrajusteapursg, $idtpajusteapsg, $cdrecesubtrib, 
                                           $cdobrigacao, $cdpais, $sgestado, $nrorg){
        /** @var $mapaapurestado Mapaapurestado */
        $mapaapurestado = Mapaapurestado::findOneByNrsequmapapuAndCdrecesubtribAndNrorg($nrsequmapapu,
                                                                                        $cdrecesubtrib, $nrorg);

        /** @var $detaufmapaest Detaufmapaest */
        $detaufmapaest = Detaufmapaest::findOneByNrsequmapapuAndCdobrigacaoAndCdpaisAndSgestadoAndNrorg($nrsequmapapu, $cdobrigacao, 
                                                                                                        $cdpais, $sgestado, $nrorg);
        
        $vrimparecolher = $mapaapurestado->getVrimparecolher();
        $vrReceita = $detaufmapaest->getVrreceita();
        if ($idtpajusteapsg == 'C'){
            $OutCredGuia = $mapaapurestado->getVroutroscreditos();
            $setOutCred = $OutCredGuia - $vrajusteapursg;
            $mapaapurestado->setVroutroscreditos($setOutCred);
            $mapaapurestado->setVrimparecolher($vrimparecolher+$vrajusteapursg);
            $setVrReceita = $vrReceita + $vrajusteapursg;
            $detaufmapaest->setVrreceita($setVrReceita);
        }
        else{
            $OutDebGuia = $mapaapurestado->getVroutrosdebitos();
            $setOutDeb = $OutDebGuia - $vrajusteapursg;
            $mapaapurestado->setVroutrosdebitos($setOutDeb);
            $mapaapurestado->setVrimparecolher($vrimparecolher-$vrajusteapursg);
            if ($vrReceita != $vrajusteapursg){
                $setVrReceita = $vrReceita - $vrajusteapursg;
                $detaufmapaest->setVrreceita($setVrReceita);
            }
            else{
                Detaufmapaest::getRepository()->DeletaRegistro($nrsequmapapu, $cdobrigacao,
                                                   $cdpais, $sgestado, $vrajusteapursg, $nrorg);
            }
        }
        
        $mapaapurestado->persist();
        $detaufmapaest->persist();
        Registry::getEntityManager()->flush();
        
        tk_reload_data_with_filter('tab_pbi00140_000_04_GuiadeArrecadacao', 'win_pbi00140_000_04');
        tk_reload_data_with_filter('tab_pbi00140_000_04_DetalhamentoporUF', 'win_pbi00140_000_04');
    }

    public static function CalcImposto($nrsequmapapu, $cdrecesubtrib, $vrcredanterior, $vroutrosdebitos,
                                       $vroutroscreditos, $nrorg){

        /** @var $mapaapurestado Mapaapurestado */
        $mapaapurestado = Mapaapurestado::findOneByNrsequmapapuAndCdrecesubtribAndNrorg($nrsequmapapu,
                                                                                        $cdrecesubtrib, $nrorg);
        $impARecolher = $mapaapurestado->getVrimparecolher();
        $setImposto = ($impARecolher-$vrcredanterior-$vroutroscreditos+$vroutrosdebitos);
        $mapaapurestado->setVrimparecolher($setImposto);
        $mapaapurestado->persist();
        $EntityManager = Registry::getEntityManager();
        $EntityManager->flush();
    }

    public static function bloqMapa($nrsequmapapu, $nrorg){

        /** @var $mapaapurac Mapaapurac */
        $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
        $mapaapurac->setIdbloqmapapu('S');

        $mapaapurac->persist();
        Registry::getEntityManager()->flush();
        tk_reload_data_with_filter('tab_pbi00140_000', 'win_pbi00140_000');
    }

    public static function desbloqMapa($nrsequmapapu, $nrorg){
        /** @var $mapaapurac Mapaapurac */
        $mapaapurac = \Fiscal\Entities\Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
        $mapaapurac->setIdbloqmapapu('N');

        $mapaapurac->persist();
        Registry::getEntityManager()->flush();
        tk_reload_data_with_filter('tab_pbi00140_000', 'win_pbi00140_000');
    }
    
    public static function ExecLucPresumido($dtiniperiodo, $dtfimperiodo, $nrsequmapapu, 
                                            $cdempresa, $cdimposto, $vroutreceitas){
        
        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $connection->beginTransaction();

        for ($i=0; $i < 1; $i++){
            $procedure = new Procedure('LUCRO_PRESUMIDO');
            $procedure->addParam(new Param('P_VROUTRECEITAS', Param::PARAM_INPUT, $vroutreceitas, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTINI', Param::PARAM_INPUT, $dtiniperiodo, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTFIM', Param::PARAM_INPUT, $dtfimperiodo, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDIMPOSTO', Param::PARAM_INPUT, $cdimposto, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $cdempresa, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRSEQUMAPAPUNF', Param::PARAM_INPUT, $nrsequmapapu, Param::PARAM_TYPE_STR));
            $procedure->call();
        }
        if ($i==0){
           $connection->rollBack();
           ExcecaoImpostosGerais::Validacao09();
        }
        elseif ($i==1){
           $connection->commit();
           tk_close_window('win_pbi00140_000_02', true);
           ExcecaoImpostosGerais::Validacao08();
        }
    }
    
    public static function CalcularOutValores($nrsequmapapu, $idtipoitmapr, $nrorg){
        /** @var $itmaparecup Itmaparecup */
        $itmaparecup = Itmaparecup::getObjectsByWhere('NRSEQUMAPAPU = ? AND IDTIPOITMAPR = ? AND NRORG = ?', 
                                                      array($nrsequmapapu, $idtipoitmapr, $nrorg)
                                                     );
        
        /** @var $maparecup Maparecup */
        $maparecup = Maparecup::findOneByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
        
        $somaValores = 0;
        /** @var $item Itmaparecup */
        foreach ($itmaparecup as $item){
            $somaValores += $item->getVritemmapr();
        }
        if ($idtipoitmapr === 'OD'){
            $maparecup->setVroutrdebi($somaValores);
        }
        elseif ($idtipoitmapr === 'EC'){
            $maparecup->setVrestocred($somaValores);
        }
            elseif ($idtipoitmapr === 'OC'){
                $maparecup->setVroutrcred($somaValores);
            }
                elseif ($idtipoitmapr === 'ED'){
                    $maparecup->setVrestodebi($somaValores);
                }
                    elseif ($idtipoitmapr === 'DD'){
                        $maparecup->setVrdeducao($somaValores);
                    }
                        elseif ($idtipoitmapr === 'DA'){
                            $maparecup->setVrdifaliqu($somaValores);
                        }
        
        $outrosDebitos = $maparecup->getVroutrdebi();
        $estornoCredito = $maparecup->getVrestocred();
        $vrnormdebi = $maparecup->getVrnormdebi();
        $maparecup->setVrtotadebi($vrnormdebi + $outrosDebitos - $estornoCredito);
        
        $outrosCreditos = $maparecup->getVroutrcred();
        $estornoDebito = $maparecup->getVrestodebi();
        $vrnormcred = $maparecup->getVrnormcred();
        $maparecup->setVrtotacred($vrnormcred + $outrosCreditos - $estornoDebito);
        
        $maparecup->persist();
        Registry::getEntityManager()->flush();
        
        tk_reload_data_with_filter('tab_pbi00140_000_OutrosValores', 'win_pbi00140_000');
        tk_reload_data_with_filter('tab_pbi00140_002', 'win_pbi00140_000');
    }

    // Formata a data de forma que possa ser inserida no banco
    public static function formataData($data)
    {
        if (strlen($data) == 19)
            $data = \Geral\Util\DateUtil::truncateString($data);
        $data = \Geral\Util\DateUtil::getDataDeString($data);
        $data = \Geral\Util\DateUtil::truncateData($data);

        return $data;
    }

    public static function insertMaparecup(
        $mapa, $vrnormdebi, $vroutrdebi, $vrestocred, $vrtotadebi, $vrnormcred, $vroutrcred,
        $vrestodebi, $vrtotacred, $vrdeducao, $vrsldcrante, $vrsaldocred, $vrdifaliqu, $vrsaldodebi,
        $vrimpcargatribm, $vrfatbrutomapr, $organizacao, $operador, $dtIncluAlt
    )
    {
        try {
            $connection = Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var Maparecup $maparecup */
            $maparecup = new Maparecup();
            $maparecup->setNrsequmapapu($mapa);
            $maparecup->setVrnormdebi($vrnormdebi);
            $maparecup->setVroutrdebi($vroutrdebi);
            $maparecup->setVrestocred($vrestocred);
            $maparecup->setVrtotadebi($vrtotadebi);
            $maparecup->setVrnormcred($vrnormcred);
            $maparecup->setVroutrcred($vroutrcred);
            $maparecup->setVrestodebi($vrestodebi);
            $maparecup->setVrtotacred($vrtotacred);
            $maparecup->setVrdeducao($vrdeducao);
            $maparecup->setVrsldcrante($vrsldcrante);
            $maparecup->setVrsaldocred($vrsaldocred);
            $maparecup->setVrdifaliqu($vrdifaliqu);
            $maparecup->setVrsaldodebi($vrsaldodebi);
            $maparecup->setVrimpcargatribm($vrimpcargatribm);
            $maparecup->setVrfatbrutomapr($vrfatbrutomapr);
            $maparecup->setNrorg($organizacao);
            $maparecup->setNrorginclusao($organizacao);
            $maparecup->setNrorgultatu($organizacao);
            $maparecup->setCdoperinclusao($operador);
            $maparecup->setCdoperultatu($operador);
            $maparecup->setDtinclusao(self::formataData($dtIncluAlt));
            $maparecup->setDtultatu(self::formataData($dtIncluAlt));
            $maparecup->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function callProcedureSubstituicaoTributaria($mapa, $organizacao) {
        try{
            $procedure = new Procedure("GERA_GUIA_ICMS_ST");
            $procedure->addParam(
                new Param(
                    'P_NRSEQUMAPAPU',
                    Param::PARAM_INPUT,
                    $mapa,
                    Param::PARAM_TYPE_STR
                )
            );
            $procedure->addParam(
                new Param(
                    'P_NRORG',
                    Param::PARAM_INPUT,
                    $organizacao,
                    Param::PARAM_TYPE_INT
                )
            );
            $procedure->call();
        } catch (\Exception $e){
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function atualizaOutrosDebitos($mapa, $pais, $estado, $outrosDebitos, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Mapaapurestado $guia */
            $guia = self::retornaGuiaArrecadacao($mapa, $pais, $estado, $organizacao);
            $guia->setVroutrosdebitos($outrosDebitos);

            $guia->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function atualizaOutrosCreditos($mapa, $pais, $estado, $outrosCredito, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Mapaapurestado $guia */
            $guia = self::retornaGuiaArrecadacao($mapa, $pais, $estado, $organizacao);
            $guia->setVroutroscreditos($outrosCredito);

            $guia->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function retornaGuiaArrecadacao($mapa, $pais, $estado, $organizacao)
    {
        try {
            $guia = Mapaapurestado::findOneByNrsequmapapuAndCdpaisAndSgestadoAndNrorg($mapa, $pais, $estado, $organizacao);
            return $guia;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function salvaCalculoValoresGuiaArrecadacao(
        $mapa, $pais, $estado, $difDebitoCredito, $creditoAnterior, $organizacao
    )
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Mapaapurestado $guia */
            $guia = self::retornaGuiaArrecadacao($mapa, $pais, $estado, $organizacao);

            if ($difDebitoCredito < 0) {
                $difDebitoCredito = $difDebitoCredito * (-1);
                $guia->setVrimparecolher(0);
                $guia->setVrsaldocredor($difDebitoCredito);
            } else {
                $guia->setVrimparecolher($difDebitoCredito);
                $guia->setVrsaldocredor(0);
            }
            $guia->setVrcredanterior($creditoAnterior);
            $guia->persist();

            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function insertOutrosValores(
        $mapa, $pais, $estado, $sequencial, $descricao, $valor, $codAjuste, $tipoAjuste, $data, $organizacao, $operador
    )
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Ajustmapaapursg $ajuste */
            $ajuste = new Ajustmapaapursg();
            $ajuste->setNrsequmapapu($mapa);
            $ajuste->setCdpais($pais);
            $ajuste->setSgestado($estado);
            $ajuste->setNrseqajusapursg($sequencial);
            $ajuste->setDsajusteapursg($descricao);
            $ajuste->setVrajusteapursg($valor);
            $ajuste->setCdajusteapursg($codAjuste);
            $ajuste->setIdtpajusteapsg($tipoAjuste);
            $ajuste->setDtinclusao(self::formataData($data));
            $ajuste->setDtultatu(self::formataData($data));
            $ajuste->setNrorg($organizacao);
            $ajuste->setNrorginclusao($organizacao);
            $ajuste->setNrorgultatu($organizacao);
            $ajuste->setCdoperinclusao($operador);
            $ajuste->setCdoperultatu($operador);
            $ajuste->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function updateOutrosValores(
        $mapa, $pais, $estado, $sequencial, $descricao, $valor, $codAjuste, $tipoAjuste, $organizacao, $operador, $data
    )
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var Ajustmapaapursg $ajuste */
            $ajuste = Ajustmapaapursg::findOneByNrsequmapapuAndCdpaisAndSgestadoAndNrseqajusapursgAndNrorg(
                $mapa, $pais, $estado, $sequencial, $organizacao
            );
            $ajuste->setDsajusteapursg($descricao);
            $ajuste->setVrajusteapursg($valor);
            $ajuste->setCdajusteapursg($codAjuste);
            $ajuste->setIdtpajusteapsg($tipoAjuste);
            $ajuste->setNrorgultatu($organizacao);
            $ajuste->setCdoperultatu($operador);
            $ajuste->setDtultatu(self::formataData($data));
            $ajuste->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function deleteOutrosValores($mapa, $pais, $estado, $sequencial, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var Ajustmapaapursg $ajuste */
            $ajuste = Ajustmapaapursg::findOneByNrsequmapapuAndCdpaisAndSgestadoAndNrseqajusapursgAndNrorg(
                $mapa, $pais, $estado, $sequencial, $organizacao
            );
            $ajuste->delete();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function insertDetalhamento(
        $ativo, $mapa, $pais, $estado, $sequencia, $obrigacao, $receita, $descricao, $processo, $origem, $valor,
        $vencimento, $organizacao, $data, $operador
    )
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Detaufmapaest $detalhamento */
            $detalhamento = new Detaufmapaest();
            $detalhamento->setIdativo($ativo);
            $detalhamento->setNrsequmapapu($mapa);
            $detalhamento->setCdpais($pais);
            $detalhamento->setSgestado($estado);
            $detalhamento->setNrsequdetuf($sequencia);
            $detalhamento->setCdobrigacao($obrigacao);
            $detalhamento->setCdreceita($receita);
            $detalhamento->setDshistorico($descricao);
            $detalhamento->setNrprocesso($processo);
            $detalhamento->setIdorigemdet($origem);
            $detalhamento->setVrreceita($valor);
            $detalhamento->setDtvencdet(self::formataData($vencimento));
            $detalhamento->setNrorg($organizacao);
            $detalhamento->setNrorginclusao($organizacao);
            $detalhamento->setNrorgultatu($organizacao);
            $detalhamento->setDtinclusao(self::formataData($data));
            $detalhamento->setDtultatu(self::formataData($data));
            $detalhamento->setCdoperinclusao($operador);
            $detalhamento->setCdoperultatu($operador);
            $detalhamento->persist();

            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function updateDetalhamento(
        $detalhamento, $obrigacao, $receita, $descricao, $processo, $origem, $valor, $vencimento, $organizacao,
        $data, $operador
    )
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Detaufmapaest $detalhamento*/
            $detalhamento->setCdobrigacao($obrigacao);
            $detalhamento->setCdreceita($receita);
            $detalhamento->setDshistorico($descricao);
            $detalhamento->setNrprocesso($processo);
            $detalhamento->setIdorigemdet($origem);
            $detalhamento->setVrreceita($valor);
            $detalhamento->setDtvencdet(self::formataData($vencimento));
            $detalhamento->setNrorgultatu($organizacao);
            $detalhamento->setDtultatu(self::formataData($data));
            $detalhamento->setCdoperultatu($operador);
            $detalhamento->persist();

            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function deleteDetalhamento($mapa, $pais, $estado, $sequencial, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Detaufmapaest $detalahemento */
            $detalahemento = Detaufmapaest::findOneByNrsequmapapuAndCdpaisAndSgestadoAndNrsequdetufAndNrorg(
                $mapa, $pais, $estado, $sequencial, $organizacao
            );
            if (!empty($detalahemento))
                $detalahemento->delete();

            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }
    /**********************Victor Novy End**********************/
}