<?php

/**
 * Gpepessoah
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 30/03/2011 09:57:10 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Gpepessoah extends DaoGpePessoah
{


    /**
     * Retorna o historico atual da pessoa informada.
     *
     * @param integer $nrorg          Numero Organizacao.
     * @param integer $nrpessoa       Numero Pessoa.
     * @param string  $dtmescompetenc Data de Competencia.
     *
     * @return array GpepessoahEntity
     *
     * @author brunofeliciano -
     *         brunofeliciano - 05/07/2011 - Inclus�o do 'DTMESCOMPETENC DESC' no sql.
     */
    public static function retornaHistoricoAtualPorPessoa($nrorg, $nrpessoa, $dtmescompetenc){

        /* Sql a ser corrigido */
         /*
        AND NRPESSOAH IN
        ( SELECT GPH.NRPESSOAH FROM GPEPESSOAH GPH,
        ( SELECT NRPESSOA, MAX(DTMESCOMPETENC) MES FROM GPEPESSOAH
        WHERE DTMESCOMPETENC <= \'?\'
        GROUP BY NRPESSOA ) GPHATUAL
        WHERE GPH.DTMESCOMPETENC = GPHATUAL.MES
        AND GPH.NRPESSOA = GPHATUAL.NRPESSOA )'
        */
        /*tk_message('NRORG '.$nrorg.', NRPESSOA '.$nrpessoa.', DTMESCOMPETENC '.$dtmescompetenc, warning);*/

        /*$dtmescompetenc = '\''.$dtmescompetenc.'\'';*/

        $pessoah = self::getObjectsByWhere(
            'NRORG = ?
             AND NRPESSOA = ?
             AND DTMESCOMPETENC <= ? ',
            array(
             $nrorg, $nrpessoa, $dtmescompetenc,
            ), 'DTMESCOMPETENC DESC'
        );
        /*$dao = $pessoah->getDao();
        $historico = self::_retornaUltimoHistorico($nrorg, $dao->NRPESSOA);
        $pessoah->historico = $historico;*/
        return $pessoah;
    }


    /**
     * Retorna o historico da pessoa informada por Mes de Competencia.
     *
     * @param integer $nrorg          Numero Organizacao.
     * @param integer $nrpessoa       Numero Pessoa.
     * @param string  $dtmescompetenc Data M�s de Compet�ncia.
     *
     * @return GpepessoahEntity
     *
     * @author brunofeliciano -
     */
    public static function retornaHistoricoPorMesCompetencia($nrorg, $nrpessoa, $dtmescompetenc){
        $pessoah = self::getObjectByWhere(
            'NRORG = ?
             AND NRPESSOA = ?
             AND DTMESCOMPETENC = ?',
            array(
             $nrorg, $nrpessoa, $dtmescompetenc,
            )
        );

        return $pessoah;
    }


    /**
     * Retorna historico.
     *
     * @param integer $nrpessoah Nr Hstorico de Pessoa.
     * @param integer $nrorg     Nr Organziacao.
     *
     * @return GpepessoahEntity
     *
     * @author luistavares - 19/08/2011
     */
    public static function retornaHistorico($nrpessoah, $nrorg){
        $pessoah = self::getObjectByWhere(
            'NRORG = ?
             AND NRPESSOAH = ?',
            array(
             $nrorg, $nrpessoah,
            )
        );

        return $pessoah;
    }


    /**
     * Retorna historico, atraves do numero da pessoa informada.
     *
     * @param integer $nrpessoa Nr Pessoa.
     * @param integer $nrorg    Nr Organziacao.
     *
     * @return GpepessoahEntity
     *
     * @author luistavares - 23/08/2011
     */
    public static function retornaHistoricoPorPessoa($nrpessoa, $nrorg){
        $pessoah = self::getObjectByWhere(
            'NRORG = ?
             AND NRPESSOA = ?',
            array(
             $nrorg, $nrpessoa,
            )
        );

        return $pessoah;
    }


    /**
     * Retorna instancia de GpepessoahEntity.
     *
     * @param integer    $nrOrg          Numero da Org. de Trabalho.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     * @param integer    $nrPessoa       Numero da Pessoa.
     *
     * @throws Exception Propaga excecao.
     *
     * @return null | GpepessoahEntity
     */
    public static function retornaPessoaHistorico($nrOrg, TkDateTime $mesCompetencia, $nrPessoa){
        try{
            /* $db = TkDb::singleton(); */
            // Query Otimizada reduzindo o alias, org ja era testado padrão   BORBA 19/03/2013
            $db = \Setforms2\Runtime\Connection::getInstance();
            // LEONARDO CARVALHO 01/11/2013 - RETORNANDO SOMENTE O HISTÓRICO ATUAL DA PESSOA
            $sql = "SELECT *
                    FROM GPE_PESSOAH EXT
                    WHERE DTMESCOMPETENC IN (
                        SELECT MAX (SUB.DTMESCOMPETENC) DTMESCOMPETENC
                        FROM GPE_PESSOAH SUB
                        WHERE /*SUB.DTMESCOMPETENC <= '$mesCompetencia'
                        AND*/ SUB.NRORG = EXT.NRORG
                        AND SUB.NRPESSOA = EXT.NRPESSOA
                        )
                    AND EXT.NRPESSOA = $nrPessoa
                    AND EXT.NRORG = $nrOrg";
            $resultado = $db->fetchAll($sql);

            return self::createObjectsFromArray($resultado);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function atualizaDadosPessoaisCurriculo($nome, $cpf, $dtnascimento, $sexo, $estadocivil,
                                                         $nacionalidade, $pais, $estado, $municipio,$dsemailoper){
        try {
            $db = \Setforms2\Runtime\Connection::getInstance();

            $sql = <<<SQL
                UPDATE GPE_PESSOAH SET NMPESSOA='$nome',
                  NRCPFPESSOA='$cpf',
                  DTNASCPESSOA='$dtnascimento',
                  IDSEXOPESSOA='$sexo',
                  CDESTACIVIL='$estadocivil',
                  NRNACIONALID='$nacionalidade',
                  CDPAIS='$pais',
                  SGESTADO='$estado',
                  CDMUNICIPIO='$municipio'
                WHERE NRPESSOA = (SELECT NRPESSOA FROM GPE_PESSOA
                                 WHERE GPE_PESSOAH.NRPESSOA       = GPE_PESSOA.NRPESSOA
                                 AND GPE_PESSOA.NRPARCNEGOCIO   =
                                        (SELECT NRPARCNEGOCIO FROM OPERADOR WHERE DSEMAILOPER = '$dsemailoper'))
SQL;
            $resultado = $db->fetchAll($sql);

        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function getUltimoHistoricoCompetencia($nrorg, $nrpessoa, $dtmescompetencia) {
        $db = self::getConnection();

        $params = array(
            'NRORG'          => $nrorg,
            'NRPESSOA'       => $nrpessoa,
            'DTMESCOMPETENC' => $dtmescompetencia
        );

        $sql = <<<SQL
SELECT *
 FROM GPE_PESSOAH
WHERE NRORG          = :NRORG
  AND NRPESSOA       = :NRPESSOA
  AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                          FROM GPE_PESSOAH
                         WHERE NRORG    = :NRORG
                           AND NRPESSOA = :NRPESSOA
                           AND DTMESCOMPETENC <= :DTMESCOMPETENC)
SQL;

        $result = $db->fetchAll($sql, $params);
        $gpepessoah = end(self::createObjectsFromArray($result));
        return $gpepessoah;
    }

}