var Dfe27500_NumeracaoInicialTransmissaoNfe_Controller = function(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService) {
    
    var widgetCabecalhoEntrada;
    var CDEMPRESA;
    var CDINSCESTA;
    
    var getNumeracaoTransmissaoNfeWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget('cabecalho');
    };
    
    this.getDefaultFilter = function(args) {
        var pai        = getNumeracaoTransmissaoNfeWidget();
        var currentRow = pai.currentRow;
        var gridAmbiente = "";
        
        if(currentRow.IDTPAMBIENTENFE === "1"){
            gridAmbiente = "Produção";
        }
        else {
            gridAmbiente = "Homologação";
        }
        
        getNumeracaoTransmissaoNfeWidget().container.getWidget('Ambiente').label = gridAmbiente;
        var row        = { CDEMPRESA: currentRow.CDEMPRESA, CDINSCESTA: currentRow.CDINSCESTA, NRINSJURIEST: currentRow.NRINSJURIEST, IDTPAMBIENTENFE: currentRow.IDTPAMBIENTENFE };
        
        General.callRestEngine("df_entrada#/getSerieNfe", "Row", row).then(success => {
            let serieNf = success.dataset.NumeracaoSerieNfe;
            let seqSerie = [];
            let rowNovoCodigo = [];
            var P_NMOPERADOR = getLocalVar("NMOPERADOR");
            var P_CDOPERADOR = getLocalVar("CDOPERADOR");
                
            serieNf.forEach(el => {
                let objNovoCodigo = {CDEMPRESA: row.CDEMPRESA, NRINSJURIEST: row.NRINSJURIEST, CDSERIENFE: el.CDSERIENFE, IDTPAMBIENTENFE: row.IDTPAMBIENTENFE};
                rowNovoCodigo.push(objNovoCodigo);
                seqSerie.push(el);
            });
            
            let novoCodigoDb = [];
            let serieFinal = [];
            
            General.callRestEngine("df_entrada#/getNovoCodigo", "Row", rowNovoCodigo).then(success => {
                let dataSetNovoCodigo = success.dataset.NumeracaoNovoCodigo;
                
                dataSetNovoCodigo.forEach(el => {
                    novoCodigoDb.push(el);
                });
                
                seqSerie.forEach(elSerie => {
                    novoCodigoDb.forEach(elNovoCodigo => {
                        if(elNovoCodigo.SERIENFE == elSerie.CDSERIENFE) {
                            let obj = {
                                CDEMPRESA: elSerie.CDEMPRESA, 
                                CDSERIENFE: elSerie.CDSERIENFE, 
                                CDINSCESTA: elSerie.CDINSCESTA, 
                                IDTPAMBIENTENFE: elSerie.IDTPAMBIENTENFE,
                                IDTIPOEMISNFE: elSerie.IDTIPOEMISNFE, 
                                NRINSJURIEST: elSerie.NRINSJURIEST, 
                                CDINSCMUNI: elSerie.CDINSCMUNI, 
                                CDSERIE: elSerie.CDSERIE, 
                                DSSERIE: elSerie.DSSERIE, 
                                SERIENFE: elNovoCodigo.SERIENFE, 
                                NRSEQUENCIAL: elNovoCodigo.NRSEQUENCIAL, 
                                NRSEQUENCIALORI: elNovoCodigo.NRSEQUENCIAL, 
                                TPAMBIENTE: elNovoCodigo.TPAMBIENTE, 
                                CDCONTADOR: elNovoCodigo.CDCONTADOR,
                                NMOPERADOR: P_NMOPERADOR, 
                                CDOPERADOR: P_CDOPERADOR};
                            serieFinal.push(obj);
                        }
                    });
                });
            
                let child = getNumeracaoTransmissaoNfeWidget().container.getWidget('Ambiente');
                child.dataSource.setData(serieFinal);
                child.reload();
                pai.reload();
            });
        });
    };
    
    this.masterDetailEdit = function(widget) {
        if(!widget.editing) {
            if(this.formChangeTemplate(widget) && widget.getParent()) {
                var widgets = widget.getParent().widgets;

                this.changeWidgetAcessibility(widgets.filter(function(w) {return w.name != widget.name;}).concat(widget.getParent()), false);
            } else this.changeWidgetAcessibility(widget.widgets, false);

            widget.backupRow = Util.clone(widget.currentRow);
            General.edit(widget);
        }
    };
    
    this.changeWidgetAcessibility = function(widgets, enabled) {
        widgets.forEach(function(widget){
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };
    
    this.formChangeTemplate = function(widget) {
        if((widget.template != "widget/master_detail/grid.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };
    
    this.masterDetailCancelForm = function(widget) {
        if(this.formChangeTemplate(widget) && widget.getParent()) {
            var widgets = widget.getParent().widgets;

            this.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
        } else this.changeWidgetAcessibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };
    
    this.masterDetailGoBackToList = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
    };

    this.saveNumeracaoInicialTransmissaoNfe = function(widget) {
        if(widget.isValid()) {
            var route = 'df_entrada#/saveNumeracaoInicialTransmissaoNfe';
            General.callRestEngine(route, 'Row', widget.currentRow)
            .then(function(response){
                ScreenService.closeSwipe();
                widget.reload();
            })
            .catch(function(error){
                ScreenService.showMessage(error.data.error);
            });
        }
        
    };
    
    this.empresaOnChange = (widget) => {
        let cnpj = widget.getField("NRINSJURIEST");
        let cnpjFilter = cnpj.dataSourceFilter.find(data => data.name === 'CDEMPRESA');
        
        if(widget.currentRow.CDEMPRESA) cnpjFilter.value = widget.currentRow.CDEMPRESA; 
        
        cnpj.readOnly = !widget.currentRow.CDEMPRESA;
        cnpj.setValue('');
        this.cnpjOnChange(widget);
    };
    
    this.cnpjOnChange = (widget) => {
        let inscricaoEstadual = widget.getField("CDINSCESTA");
        
        if(widget.currentRow.NRINSJURIEST) {
            inscricaoEstadual.dataSourceFilter.forEach( (data) => {
                if(data.name == 'CDEMPRESA')    data.value = widget.currentRow.CDEMPRESA;
                if(data.name == 'NRINSJURIEST') data.value = widget.currentRow.NRINSJURIEST;
            });
        }
        inscricaoEstadual.readOnly = !widget.currentRow.NRINSJURIEST;
        inscricaoEstadual.setValue('');
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe27500_NumeracaoInicialTransmissaoNfe_Controller', Dfe27500_NumeracaoInicialTransmissaoNfe_Controller);
});